# Virgodev Websocket Support

provides a uniform system for sending and receiving websocket messages


## specs

- [ ] documentation for connecting django-channels
- [x] support functions for making django-channels easy
  - [x] signal for when a message is received
  - [x] create a function to send messages to a user
  - [x] create a function to send messages to a group


## Get Started

1. Install virgodev_websocket_support

    ```python
    pip install virgodev_websocket_support
    ```

1. Add INSTALLED_APPS setting

    ```python
    INSTALLED_APPS = (
        "daphne",  # install at the top to convert `runserver` into a websocket client
        "django.contrib.auth",
        "django.contrib.contenttypes",
        "django.contrib.sessions",
        "django.contrib.sites",
        "virgodev_websocket_support",
        ...
    )
    ```

1. Add ASGI_APPLICATION setting

    ```python
    ASGI_APPLICATION = 'virgodev_websocket_support.asgi.application'
    ```

    or use the asgi from your own application's asgi file

    ```python
    from virgodev_websocket_support.asgi import application as app
    application = app
    ```


1. Add CHANNEL_LAYERS setting

    assign the host to the same redis instance as your cache

    ```python
    CHANNEL_LAYERS = {
        "default": {
            "BACKEND": "channels_redis.core.RedisChannelLayer",
            "CONFIG": {
                "hosts": [CACHES["default"]["LOCATION"]],
                "group_expiry": 60 * 10,
            },
        },
    }
    ```

## Production

install and use uvicorn
